require_relative 'trie_node'

class TrieStruct
  attr_accessor :root_node, :generated_words

  def initialize(word)
    self.generated_words = []
    self.root_node = TrieNode.create(word, nil, self)
    return self.root_node
  end

  def to_h
    self.root_node.to_h
  end

  def to_words
    self.root_node.to_a if self.generated_words.empty?
    self.generated_words.flatten.compact.sort
  end

  def insert(word)
    self.root_node.insert_word(word)
  end

end
